// functions for control :
//list :

#ifndef DEF_FONCTIONS_H
#define DEF_FONCTIONS_H
#include <Arduino.h>
#include <Servo.h>
#include <DRV8825.h>
#include <Wire.h>

extern Servo magnetServo, myServo;

extern DRV8825 linearMvmtStep;


extern DRV8825 rotativePlateStep;

// Pipette linear guide
void linearTop(int height); //[move pipette to bottom of tube]
void linearBottom(int height); //[move pipette above tube]
int linearPipetteSetup(int steps);

// Central plate motor
void rotatePlate(float angle); // [rotate plate from angle]
void movePlate(int steps);
void moveToStep(int currentStep, int goalStep);
int rotativePlateSetup_Peltier(int steps);
int rotativePlateSetup_Ampli(int steps);
int rotativePlateSetup_HeatingTransfo(int steps);

// Magnet
void ActivateMagnet(); //[bring magnets close to the tubes]
void DeactivateMagnet(); // [bring magnets far away from the tubes]

// Pipette control
void initPipette(); // [initialize pipette : pins and start of pipette]
void triggerButton( int pin ); // [trigger a button using a transistor]
void aspirate();
void goAspirate(int height); //go down, aspirate, go back up
void dispense();
void goDispense(int height); //go down, dispense, go back up
void setvolume_flush(int volume_end, int volume_start);
void setvolume(int volume_end, int volume_start); // [set the volume]

void triggerButton_Long( int pin );
void triggerButton_Delay( int pin , unsigned long time_delay);
unsigned long compute_delay(int delta_V); // [compute the delay in order to set the volume]
unsigned long compute_delay_flush(int delta_V);
void setspeed(int speed_start_in, int speed_end_in, int speed_start_out, int speed_end_out); // [Set the Speeds IN/OUT from 1 to 9]
void mode_P_to_flush();
void mode_flush_to_P();
void flushing(); //mix solution
void takeTip(); //
void releaseTip();

// Temperature control
float tempAvg();
int tempMonitoringCool(float resultTemp, float wantedTemp);
int tempMonitoringHeat(float resultTemp, float wantedTemp);
int heatSample(float wantedTemp);
int heatAmplification(float wantedTemp);
int coolSample(float wantedTemp);

// Actuator
void SetStrokePerc(float strokePercentage);
void SetStrokeMM(int strokeReq, int strokeMax);

#endif


